package cn.com.qmth.stmms.biz.report.dao;

import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import cn.com.qmth.stmms.biz.report.model.ReportSubjectGroup;

/**
 * 大题成绩分析 Dao
 *
 * @author xuwenjin
 * @date 2019-04-18
 */
public interface ReportSubjectGroupDao extends PagingAndSortingRepository<ReportSubjectGroup, Integer>,
        JpaSpecificationExecutor<ReportSubjectGroup> {

    @Modifying
    @Query("delete from ReportSubjectGroup r where r.examId=?1 ")
    void deleteByExamId(Integer exmaId);

    @Modifying
    @Query("update ReportSubjectGroup r set r.questionCount = (select count(*) from ExamQuestion q where q.examId=?1 and q.groupNumber = r.groupNumber and q.subjectCode = r.subjectCode and q.examId = r.examId ) where r.examId=?1  ")
    void updateQuestionCount(Integer examId);

}
