package cn.com.qmth.stmms.biz.report.utils.module;

import cn.com.qmth.stmms.biz.exam.model.ExamStudent;
import cn.com.qmth.stmms.biz.report.model.ReportSubjectClassGroup;
import cn.com.qmth.stmms.biz.report.service.ReportSubjectClassGroupService;
import cn.com.qmth.stmms.biz.report.utils.Module;
import cn.com.qmth.stmms.biz.report.utils.QuestionGroup;
import cn.com.qmth.stmms.biz.report.utils.ReportContext;
import cn.com.qmth.stmms.biz.report.utils.unit.BaseCalculatorUnit;
import cn.com.qmth.stmms.biz.utils.SpringContextHolder;

public class SubjectClassGroupModule extends SubjectGroupModule implements Module {

    public SubjectClassGroupModule(ReportContext context) {
        super(context);
    }

    public String getKey(ExamStudent student, QuestionGroup group) {
        return student.getSubjectCode() + "\t" + student.getClassName() + "\t" + group.isObjective() + "\t"
                + group.getNumber();
    }

    public void save() {
        ReportSubjectClassGroupService service = SpringContextHolder.getBean(ReportSubjectClassGroupService.class);
        for (String key : this.calculators.keySet()) {
            String s[] = key.split("\t");
            if (s.length > 3) {
                String subjectCode = s[0];
                String className = s[1];
                Boolean objective = Boolean.parseBoolean(s[2]);
                Integer mainNumber = Integer.parseInt(s[3]);
                BaseCalculatorUnit unit = calculators.get(key);
                ReportSubjectClassGroup r = new ReportSubjectClassGroup();
                r.setExamId(this.context.getExamId());
                r.setSubjectCode(subjectCode);
                r.setClassName(className);
                r.setSubjectName(context.getSubject(subjectCode).getName());
                r.setGroupName(context.getGroup(subjectCode + "\t" + objective + "\t" + mainNumber).getMainTitle());
                r.setGroupNumber(mainNumber);
                r.setTotalScore(unit.fullScore);
                r.setObjective(objective);
                r.setDiscrimination(unit.discrimination);
                r.setDifficulty(unit.difficulty);
                r.setCoefficient(unit.coefficient);
                service.save(r);
            }
        }
    }

}
